/**
 * Copyright 2005 Sun Microsystems Inc. All rights reserved. Use is subject to license terms.
 */
package com.sunlabs.archsim.classRegistry;

import junit.framework.TestCase;
import junit.textui.TestRunner;

/**
 * @author ib27688
 *
 */
public class ClassRegistryTest extends TestCase {
	
	
	public static void main(String[] args) {
		TestRunner.run(ClassRegistryTest.class);
	}
	
	public void setUp() {
		
	}
	
	public void tearDown() {
		
	}
	
	public void testConsistency() {
		ClassRegistry reg=  ClassRegistry.instance;
		reg.clear();
		reg.load("src/" 
				+ ClassRegistryTest.class.getPackage().getName().replace('.', '/')
				+ "/library.xml");
		
		for (String name : reg.componentNames()) {
			ComponentInfo ci= reg.getComponentInfo(name);
			// the names must be the same
			assertEquals(name, ci.getName());
			
			// the classes must be the same
			try {
				Class nameClass= Class.forName(name);
				assertEquals(nameClass, ci.getComponentType());
			}
			catch (ClassNotFoundException e) {
				assert(false);
			}
			
		}		
	}
	
	public void testClear() {
		ClassRegistry reg=  ClassRegistry.instance;
		reg.clear();
		assertEquals(reg.size(), 0);
	}

}
